#include "GLSLModel.h"


void GLSLModel::LoadShaderFile(GLuint id, const char *argFileName)
{
	// t@C̒gSēǂݍ
	std::ifstream inputFile1(argFileName);
	std::istreambuf_iterator<char> vdataBegin(inputFile1);
	std::istreambuf_iterator<char> vdataEnd;
	std::string fileData1(vdataBegin,vdataEnd);
	const char *pFile = fileData1.c_str();

	// VF[_RpC
	glShaderSource(id, 1, &pFile, NULL);
	glCompileShader(id);
	// G[`FbN͕ʊ֐ɂ

	return;
}

bool GLSLModel::PrintShaderInfoLog(GLuint shader)
{
	GLsizei bufSize;

	/* VF[_̃RpC̃O̒擾 */
	glGetShaderiv(shader, GL_INFO_LOG_LENGTH , &bufSize);

	if(bufSize > 1) {
		GLchar *infoLog = (GLchar *)malloc(bufSize);

		if(infoLog != NULL) {
			GLsizei length;

			/* VF[_̃RpC̃O̓e擾 */
			glGetShaderInfoLog(shader, bufSize, &length, infoLog);
			fk_Printf("InfoLog:\n%s\n\n", infoLog);
			free(infoLog);
		} else {
			fk_Printf("Could not allocate InfoLog buffer.\n");
		}

		return false;
	}

	return true;
}

GLSLModel::GLSLModel(void) : fk_Model(),
	vpID(0), fpID(0), shID(0), useTex(false), useSatBle(false)
{
	return;
}

GLSLModel::~GLSLModel()
{
	glDeleteShader(vpID);
	glDeleteShader(fpID);
	glDeleteProgram(shID);
}

void GLSLModel::initShader(const char  *argVPName, const char *argFPName)
{
	vpID = glCreateShader(GL_VERTEX_SHADER);
	LoadShaderFile(vpID, argVPName);
	PrintShaderInfoLog(vpID);

	fpID = glCreateShader(GL_FRAGMENT_SHADER);
	LoadShaderFile(fpID, argFPName);
	PrintShaderInfoLog(fpID);

	shID = glCreateProgram();
	glAttachShader(shID, vpID);
	glAttachShader(shID, fpID);

	GLint	linked = 0;
	glLinkProgram(shID);
	glGetProgramiv(shID, GL_LINK_STATUS, &linked);
	if(linked == GL_FALSE) {
		fk_Printf("Shader Link Err.\n");
	}

	return;
}

void GLSLModel::setTexUse(bool argMode)
{
	useTex = argMode;
	if(useTex) {
		glUniform1i(glGetUniformLocation(shID, "tex0"), 0);
	}
}

void GLSLModel::setSatUse(bool argMode)
{
	useSatBle = argMode;
}

void GLSLModel::preShader(void)
{
	if(useSatBle) glBlendFunc(GL_ONE, GL_ONE);
	glUseProgram(shID);

	return;
}	

void GLSLModel::postShader(void)
{
	glUseProgram(0);
	if(useSatBle) glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	return;
}
